package edu.fudan.cube;

import java.awt.Color;
import java.awt.image.BufferedImage;

import edu.fudan.cube.core.Point;

/**
 * Basic graphics operations.
 * Draw single pixel and do the projection.
 * 
 * @author Lei Huang
 */
public class DrawUtil3D {
	/**
	 * Project the points to the pixels.
	 */
    public static Point project(Point point) {
        Point newPoint =  new Point(point.getX(), point.getY(), point.getZ());
        newPoint.setX(newPoint.getX() / Math.log(newPoint.getZ() + 5));
        newPoint.setY(newPoint.getY() / Math.log(newPoint.getZ() + 5));
        newPoint.setZ(0.0);

        newPoint.setX(newPoint.getX() * 100 + 200);
        newPoint.setY(newPoint.getY() * 100 + 200);

        return newPoint;
    }

	/**
	 * draw one pixel with color.
	 */
    public static void drawPixel(BufferedImage image, int x, int y, Color color) {
        image.setRGB(x, y, color.getRGB());
    }
}
