package edu.fudan.poly;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

/**
 * Get and create the BufferedImage as a singleton.
 * 
 * @author Lei Huang
 */
public class ImageWrapper {
	private static BufferedImage image;

	public static BufferedImage get(Dimension dimension) {
		if (image == null) {
			image = new BufferedImage(dimension.width, dimension.height,
					BufferedImage.TYPE_3BYTE_BGR);

			Graphics graphics = image.getGraphics();
			graphics.setColor(Color.WHITE);
			graphics.fillRect(0, 0, dimension.width, dimension.height);
		}

		return image;
	}

	public static BufferedImage get() {
		return image;
	}
}
