package edu.fudan.poly.core;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import edu.fudan.poly.ImageWrapper;

/**
 * A single polygon which consists of a list of points. Draw the polygon when
 * any changes applied.
 * 
 * @author Lei Huang
 */
public class Polygon {

	List<Point> points = new ArrayList<Point>();
	
	public Polygon(Point curPoint) {
		points.add(curPoint);
	}

	/**
	 * Get the point if the location is nearest.
	 */
	public int getPoint(int x, int y) {
		Point point = new Point(x, y);
		for (int index = 0; index < points.size(); index++) {
			if (point.distance(points.get(index)) < 10) {
				return index;
			}
		}
		return -1;
	}

	/**
	 * Set point to the index position.
	 */
	public void setPoint(int index, Point point) {
		Point originalPoint = points.get(index);
		points.set(index, point);
		PolygonUtil.drawModifiedTriangle(points.get((index + points.size() - 1) % points.size()),
				points.get((index + 1) % points.size()), originalPoint, point, ImageWrapper.get());
	}

	/**
	 * Append a new point
	 */
	public void addPoint(Point point) {
		points.add(point);
		PolygonUtil.drawNewTriangle(points.get(0), points.get(points.size() - 2),
				points.get(points.size() - 1), ImageWrapper.get());
	}
}
